// Dodavanje novih zapisa u datoteku o stediama.

#include <stdio.h>
#include "stedisa.h"

int main() {

  // Otvaranje datoteke o tediama:
  FILE *stednja;              // - datoteka o tediama
  unsigned int veldat;        // - broj zapisa u datoteci.
  if ((stednja = fopen("stedise.dat", "r+b")) != NULL)
    // Datoteka postoji, itanje broja zapisa u datoteci.
    fread(&veldat, sizeof veldat, 1, stednja);
  else {
    // Datoteka ne postoji, stvaranje prazne datoteke.
    stednja = fopen("stedise.dat", "w+b"); veldat = 0;
    fwrite(&veldat, sizeof veldat, 1, stednja);
  }

  // Dodavanje zapisa o novim tediama:
  while (1) {

    // itanje podataka o tedii:
    unsigned int sifra;       // - ifra tedie
    printf("\nSifra stedise?     "); scanf("%d", &sifra);
  if (sifra == 0) break;      // - zavretak programa.
    Stedisa stedisa;          // - podaci o jednom stedii
    printf("Prezime stedise?   ");
    scanf("%s", stedisa.ime.prezime);
    printf("Licno ime stedise? ");
    scanf("%s", stedisa.ime.licno_ime);
    stedisa.stanje = 0;

    // Priprema za upisivanje podataka u datoteku:
    if (sifra > veldat) {
      // Novi zapis je iza kraja datoteke, promena veliine datoteke.
      fseek(stednja, 0L, SEEK_END);
      Stedisa prazno = {0};   // - prazan zapis (sadri sve nule)
      while (++veldat < sifra) fwrite(&prazno, sizeof prazno, 1, stednja);
      veldat = sifra;
    } else
      // Novi zapis je pre kraja datoteke, nalaenje njegovog mesta.     
      fseek(stednja,
            sizeof veldat + (long) (sifra - 1) * (sizeof stedisa),
            SEEK_SET);

    // Upisivanje podataka u datoteku:
    fwrite(&stedisa, sizeof stedisa, 1, stednja);
    rewind(stednja); fwrite(&veldat, sizeof veldat, 1, stednja);
  }
}
